/* !!!
 * If you're looking at config.c and thinking of editing - this is a
 * generated file. See build/config.c.in, unless you're just twiddling
 * to get things to work on your platform before updating Configure,
 * in which case go right ahead. :-)
 * !!!
 */

#include "moar.h"
#include "gen/config.h"

#define add_entry(tc, hash, name, value) do { \
    MVMString * const key = MVM_string_ascii_decode_nt(tc, tc->instance->VMString, (name)); \
    MVMROOT(tc, key, { \
        MVMString * const value_str = MVM_string_ascii_decode_nt(tc, tc->instance->VMString, (value)); \
        MVMObject * const boxed_value = MVM_repr_box_str(tc, MVM_hll_current(tc)->str_box_type, value_str); \
        MVM_repr_bind_key_o(tc, hash, key, boxed_value); \
    }); \
} while (0)

MVMObject *MVM_backend_config(MVMThreadContext *tc) {
    MVMObject *config = MVM_repr_alloc_init(tc, tc->instance->boot_types.BOOTHash);
    MVMROOT(tc, config, {
        add_entry(tc, config, "exe", "");
        add_entry(tc, config, "uvrule", "@:");
        add_entry(tc, config, "dllimport", "__attribute__ ((visibility (\"default\")))");
        add_entry(tc, config, "moarlib", "libmoar.a");
        add_entry(tc, config, "nul", "/dev/null");
        add_entry(tc, config, "laoobjects", "");
        add_entry(tc, config, "usrlibs[0]", "uv");
        add_entry(tc, config, "usrlibs[1]", "sha");
        add_entry(tc, config, "usrlibs[2]", "readline");
        add_entry(tc, config, "dcbclean", "$(RM) 3rdparty/dyncall/dyncallback/libdyncallback_s.a");
        add_entry(tc, config, "shareddir", "lib");
        add_entry(tc, config, "be", "1");
        add_entry(tc, config, "ldusr", "-l%s");
        add_entry(tc, config, "tomlib", "3rdparty/libtommath/libtommath.a");
        add_entry(tc, config, "dcrule", "cd 3rdparty/dyncall &&  ./configure && CC='$(CC)' CFLAGS='$(CFLAGS)' $(MAKE) -f Makefile ");
        add_entry(tc, config, "ldout", "-o ");
        add_entry(tc, config, "lnlib", "__ln__");
        add_entry(tc, config, "obj", ".o");
        add_entry(tc, config, "sharedlib", "");
        add_entry(tc, config, "tomrule", "$(AR) $(ARFLAGS) $@ 3rdparty/libtommath/*.o");
        add_entry(tc, config, "noreturnattribute", "__attribute__((noreturn))");
        add_entry(tc, config, "ccdef", "-D");
        add_entry(tc, config, "defs[0]", "_REENTRANT");
        add_entry(tc, config, "defs[1]", "_FILE_OFFSET_BITS=64");
        add_entry(tc, config, "ldrpath", "-Wl,-rpath,$(PREFIX)/lib");
        add_entry(tc, config, "laorule", "@:");
        add_entry(tc, config, "dllexport", "__attribute__ ((visibility (\"default\")))");
        add_entry(tc, config, "dlrule", "@:");
        add_entry(tc, config, "ldinstflags", "-pg");
        add_entry(tc, config, "ldsys", "-l%s");
        add_entry(tc, config, "moardll", "libmoar.so");
        add_entry(tc, config, "versionmajor", "2014");
        add_entry(tc, config, "ccinc", "-I");
        add_entry(tc, config, "dclib", "3rdparty/dyncall/dyncall/libdyncall_s.a");
        add_entry(tc, config, "versionpatch", "0");
        add_entry(tc, config, "syslibs[0]", "m");
        add_entry(tc, config, "syslibs[1]", "pthread");
        add_entry(tc, config, "syslibs[2]", "rt");
        add_entry(tc, config, "syslibs[3]", "dl");
        add_entry(tc, config, "make", "make");
        add_entry(tc, config, "lnclean", "@:");
        add_entry(tc, config, "lddebugflags", "-g3");
        add_entry(tc, config, "laoclean", "@:");
        add_entry(tc, config, "shaobjects", "");
        add_entry(tc, config, "mainflags", "-DMVM_SHARED");
        add_entry(tc, config, "lddir", "-L");
        add_entry(tc, config, "noreturnspecifier", "");
        add_entry(tc, config, "perl", "/usr/bin/perl");
        add_entry(tc, config, "thirdpartylibs", "3rdparty/dyncall/dyncallback/libdyncallback_s.a 3rdparty/libtommath/libtommath.a 3rdparty/dyncall/dyncall/libdyncall_s.a 3rdparty/dyncall/dynload/libdynload_s.a 3rdparty/tinymt/libtinymt.a");
        add_entry(tc, config, "cflags", "-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches  -m32 -fPIC");
        add_entry(tc, config, "dlclean", "$(RM) 3rdparty/dyncall/dynload/libdynload_s.a");
        add_entry(tc, config, "ldflags", "-Wl,-z,relro ");
        add_entry(tc, config, "uvclean", "@:");
        add_entry(tc, config, "ldlibs", "-luv -lsha -lreadline -lm -lpthread -lrt -ldl -ltommath");
        add_entry(tc, config, "dcblib", "3rdparty/dyncall/dyncallback/libdyncallback_s.a");
        add_entry(tc, config, "moarinst", "lib");
        add_entry(tc, config, "platform", "$(PLATFORM_POSIX)");
        add_entry(tc, config, "hasreadline", "1");
        add_entry(tc, config, "sh", "/bin/sh");
        add_entry(tc, config, "ccmiscflags", "");
        add_entry(tc, config, "mtclean", "$(RM) 3rdparty/tinymt/libtinymt.a 3rdparty/tinymt/*.o");
        add_entry(tc, config, "auxclean", "@:");
        add_entry(tc, config, "uvobjects", "");
        add_entry(tc, config, "ccout", "-o ");
        add_entry(tc, config, "ccinstflags", "-pg");
        add_entry(tc, config, "versionminor", "04");
        add_entry(tc, config, "dcobjects", "");
        add_entry(tc, config, "dllib", "3rdparty/dyncall/dynload/libdynload_s.a");
        add_entry(tc, config, "ccswitch", "-c");
        add_entry(tc, config, "prefix", "/usr");
        add_entry(tc, config, "dcbrule", "@:");
        add_entry(tc, config, "ar", "ar");
        add_entry(tc, config, "ccshared", "-fPIC");
        add_entry(tc, config, "ld", "gcc");
        add_entry(tc, config, "dlllocal", "__attribute__ ((visibility (\"hidden\")))");
        add_entry(tc, config, "ldimp", "");
        add_entry(tc, config, "mainlibs", "-L. -lmoar");
        add_entry(tc, config, "lnrule", "@:");
        add_entry(tc, config, "lib", "lib%s.a");
        add_entry(tc, config, "moarshared", "");
        add_entry(tc, config, "uvlib", "__uv__");
        add_entry(tc, config, "ccwarnflags", "");
        add_entry(tc, config, "staticlib", "");
        add_entry(tc, config, "mtrule", "$(AR) $(ARFLAGS) $@ 3rdparty/tinymt/*.o");
        add_entry(tc, config, "dcclean", "cd 3rdparty/dyncall && $(MAKE) -f Makefile clean");
        add_entry(tc, config, "mknoisy", "ifneq ($(NOISY), 1)\
MSG = @echo\
CMD = @\
NOOUT = > /dev/null\
NOERR = 2> /dev/null\
endif\
");
        add_entry(tc, config, "dcbobjects", "");
        add_entry(tc, config, "arout", "");
        add_entry(tc, config, "ccoptiflags", "-O1 -DNDEBUG");
        add_entry(tc, config, "tomobjects", "3rdparty/libtommath/bn_mp_get_long.o 3rdparty/libtommath/bn_mp_set_long.o");
        add_entry(tc, config, "ccdefflags", "-D_REENTRANT -D_FILE_OFFSET_BITS=64");
        add_entry(tc, config, "version", "2014.04");
        add_entry(tc, config, "rm", "rm -f");
        add_entry(tc, config, "laolib", "__lao__");
        add_entry(tc, config, "sharule", "@:");
        add_entry(tc, config, "ldmiscflags", "");
        add_entry(tc, config, "static_inline", "static __inline__");
        add_entry(tc, config, "profilecalls", "0");
        add_entry(tc, config, "dlobjects", "");
        add_entry(tc, config, "cc", "gcc");
        add_entry(tc, config, "crossconf", "");
        add_entry(tc, config, "arflags", "rcs");
        add_entry(tc, config, "staticdir", "lib");
        add_entry(tc, config, "shalib", "__sha__");
        add_entry(tc, config, "mtlib", "3rdparty/tinymt/libtinymt.a");
        add_entry(tc, config, "os", "linux");
        add_entry(tc, config, "impinst", "");
        add_entry(tc, config, "moar", "libmoar.so");
        add_entry(tc, config, "shaclean", "@:");
        add_entry(tc, config, "dll", "lib%s.so");
        add_entry(tc, config, "mtobjects", "3rdparty/tinymt/tinymt64.o");
        add_entry(tc, config, "lnobjects", "");
        add_entry(tc, config, "ldshared", "-shared -fPIC");
        add_entry(tc, config, "osname", "linux");
        add_entry(tc, config, "objflags", "-DMVM_BUILD_SHARED -fPIC");
        add_entry(tc, config, "shaincludedir", "/usr/include/sha");
        add_entry(tc, config, "tomclean", "$(RM) 3rdparty/libtommath/libtommath.a 3rdparty/libtommath/*.o");
        add_entry(tc, config, "name", "moar");
        add_entry(tc, config, "ldoptiflags", "-O1 -DNDEBUG");
        add_entry(tc, config, "osvers", "2.6.32-279.19.1.el6.ppc64");
        add_entry(tc, config, "cat", "cat");
        add_entry(tc, config, "config", "--prefix=/usr --has-libtommath --use-readline --has-sha --has-libuv --has-libatomic_ops");
        add_entry(tc, config, "ccdebugflags", "-g3");
        add_entry(tc, config, "mkflags", "");

    });

    return config;
}
